#include "ADO.au3"

#REMARK
#CS
	To use this example here:
	You should create [AutoIt_Test_DataBase] in MS SQL Server (could be Express edition)
#CE

_ADO_ComErrorHandler_UserFunction(_ADO_COMErrorHandler)

ConsoleWrite(@CRLF)
ConsoleWrite(@CRLF)
ConsoleWrite('EXAMPLE START' & @CRLF)
_Example()
ConsoleWrite('EXAMPLE START' & @CRLF)
ConsoleWrite(@CRLF)
ConsoleWrite(@CRLF)

Func _Example()

	Local $sPassword = 'AutoIt' ; CHANGE TO YOUR OWN PASS
	Local $sInstance = 'localhost\SQLExpress' ; CHANGE TO YOUR OWN MS SQL SERVER INSTANCES
	Local $oConnection = _ADO_Connection_Create()
	_ADO_Connection_OpenConString($oConnection, "PROVIDER=SQLOLEDB.1;SERVER=" & $sInstance & ";uid=sa;pwd=" & $sPassword & ";")

	; TRY TO USE EACH OF THIS 2 FOLLOWING LINE, JUST COMMENT FIRST OR SECOND LINE
;~ 	_ADO_EVENTS_ShowOnly_InfoMessages(False)
	_ADO_EVENTS_ShowOnly_InfoMessages(True)

	_ADO_Execute($oConnection, "CREATE TABLE [AutoIt_Test_DataBase].dbo.[AutoIt_ADO_UDF_TestTable]( [Test] [nchar](100) NULL) ON [PRIMARY]")
	If @error Then ConsoleWrite('! ---> @error=' & @error & '  @extended=' & @extended & ' : CREATE TABLE' & @CRLF)

	; LET INSERT SOME DATA
	Local $sContent = 'Testing ADO EVENTS'
	Local $sContent_Updated = 'Testing ADO EVENTS UPDATED'
	Local $sSQL_Query_Insert = _
			"INSERT INTO [AutoIt_Test_DataBase].dbo.[AutoIt_ADO_UDF_TestTable]" & @CRLF & _
			"([Test]) VALUES ('" & $sContent & "')" & @CRLF & _
			""
	_ADO_Execute($oConnection, $sSQL_Query_Insert)
	_ADO_Execute($oConnection, $sSQL_Query_Insert)
	_ADO_Execute($oConnection, $sSQL_Query_Insert)

	Local $sSQL_Query_Update = _
			"UPDATE [AutoIt_Test_DataBase].dbo.[AutoIt_ADO_UDF_TestTable]" & @CRLF & _
			"SET [Test]='" & $sContent_Updated & "'" & @CRLF & _
			"WHERE [Test]='" & $sContent & "'" & @CRLF & _
			""
	_ADO_Execute($oConnection, $sSQL_Query_Update)
	ConsoleWrite('- UPDATE: RowAffected=' & @extended & @CRLF)

	; SHOW TABLE CONTENT
	Local $oRecordeset = _ADO_Execute($oConnection, _
			"SELECT *" & @CRLF & _
			"FROM [AutoIt_Test_DataBase].dbo.[AutoIt_ADO_UDF_TestTable]" & @CRLF & _
			"")
	_ADO_Recordset_Display($oRecordeset, 'SHOW TABLE CONTENT')

	; DELETE THEM
	_ADO_Execute($oConnection, _
			"DELETE" & @CRLF & _
			"FROM [AutoIt_Test_DataBase].dbo.[AutoIt_ADO_UDF_TestTable]" & @CRLF & _
			"WHERE [Test]='" & $sContent_Updated & "'" & @CRLF & _
			"")
	If @error Then
		ConsoleWrite('! ---> @error=' & @error & '  @extended=' & @extended & ' : ' & @CRLF)
	Else
		ConsoleWrite('- DELETE: RowAffected=' & @extended & @CRLF)
	EndIf

	_ADO_EVENTS_ShowOnly_InfoMessages(True)
	ConsoleWrite('! ' & @ScriptLineNumber & ' : ' & _ADO_EVENTS_ShowOnly_InfoMessages() & @CRLF)
	_ADO_Execute($oConnection, "PRINT 'this is a test - hello - Line 1'")

	_ADO_EVENTS_ShowOnly_InfoMessages(False)
	ConsoleWrite('! ' & @ScriptLineNumber & ' : ' & _ADO_EVENTS_ShowOnly_InfoMessages() & @CRLF)
	_ADO_Execute($oConnection, "DROP TABLE [AutoIt_Test_DataBase].[dbo].[AutoIt_ADO_UDF_TestTable]")
EndFunc   ;==>_Example

